# NOTE: Derived from blib/lib/Ferret.pm.
# Changes made here will be lost when autosplit again.
# See AutoSplit.pm.
package Ferret;

#line 2661 "blib/lib/Ferret.pm (autosplit into blib/lib/auto/Ferret/LoadHTTP.al)"
sub LoadHTTP {
	my $usage = 'Usage: $data = Ferret::LoadHTTP(WEBFILE, [REQUEST-OPTIONS, METHOD, MAXSIZE])';
	@_ >= 1 && @_ <= 3 or croak $usage;
	my($addr,$opts,$method,$size) = @_;

	croak $usage if (ref $addr eq "Ferret");
	$addr =~ s/\#.*$//;

	my($http,$junk,$type,$host,$port,$data);
	($http,$junk,$user,$host,$port,$file) = ($addr =~ m|^(http:)?(//)?([^:@]*:[^:@]*@)?([^/:]*)?(:\d*)?(/.*)$|i);
	die "Error: Badly formed HTTP address '$file'; stopped" unless $file;
	die "Error: LoadHTTP cannot handle url in the form '$addr'; stopped" if ($http && $http !~ m/^http:$/i);
	$host = "localhost" unless $host;
	$port =~ s/^://;
	$port = 80 unless $port;
	$size = 16*1024*1024 unless $size;

	use IO::Handle;
	use Socket;

	my($proto,$sin,$ipaddr);

	chop($user);
	$opts .= "Host: $host\n" unless $opts =~ m/^Host:/mi;
	$opts .= "Accept: */*\n" unless $opts =~ m/^Accept:/mi;
	$opts .= "Authorization: Basic " . BasicAuthorization($user) . "\n" if $user;
	$method= "GET" unless $method;

	$timeout = $headtimeout if     $method eq "HEAD";
	$timeout = $gettimeout  if     $method eq "GET";
	$timeout = $nettimeout  unless $timeout > 0;
	$timeout = 300          unless $timeout > 0;

#	print STDERR "$$: LoadHTTP '$addr' starting...\n";
#	print STDERR $opts;
	local $SIG{ALRM} = sub { die "Error: Timeout building connection to '$addr'\n" };
	alarm ($timeout/5 > 5 ? $timeout/5 : 5);
	$proto = getprotobyname('tcp');
	socket(SOCK, PF_INET, SOCK_STREAM, $proto);
	$ipaddr = inet_aton($host) || die "Error: Could not locate machine '$host'\n";
	$sin = sockaddr_in($port,$ipaddr);
#	print STDERR "$$:  connecting...\n";
	connect(SOCK,$sin) || die "Error: Could not connect to machine '$host' on port $port\n";
	alarm 0;

	local $SIG{ALRM} = sub { die "Error: Timeout waiting for data from '$addr' (got ",length($data),")\n" };
#	local $SIG{ALRM} = sub { print STDERR "Warning: Timeout waiting for data from '$addr' (got ",length($data),")\n" };
	alarm $timeout;
	autoflush SOCK 1;
#	print STDERR "$$:  fetching...\n";
	print SOCK "$method $file HTTP/1.0\n$opts\n" || die "Error: Could not write to socket -- $!; stopped";
	select '','','',0.1; shutdown(SOCK,1);
	read(SOCK,$data,$size);
	close(SOCK);
	alarm 0;
#	print STDERR "$$:  done\n";

	die "Error: No data from server for '$addr'\n" unless $data;

	return($data);
}

# end of Ferret::LoadHTTP
1;
