# NOTE: Derived from blib/lib/Ferret.pm.
# Changes made here will be lost when autosplit again.
# See AutoSplit.pm.
package Ferret;

#line 1163 "blib/lib/Ferret.pm (autosplit into blib/lib/auto/Ferret/StripHTML.al)"
###############################################################################
#
# Document importing utilities
#


sub StripHTML {
	my $usage = 'Usage: Ferret::StripHTML(\$htmldata [, \$title [, \$summary [, SUMMARYSIZE]]])';
	@_ >= 1 && @_ <= 4 or croak $usage;
	my($doc,$title,$summary,$amount) = @_;

	croak $usage if (ref $doc ne "SCALAR");
	croak $usage if ($title && ref $title ne "SCALAR");
	croak $usage if ($summary && ref $summary ne "SCALAR");

	my($frameflag,$extrawords);
	$amount = 512 unless defined $amount;

	FixCRLF($doc);

	if ($title) {
		$$title = "";
		if ($$doc =~ m!<title>(.*?)</title>!is) {
			$$title = $1;
		}
	}

	$frameflag = ($$doc =~ m/<frame/);
	$extrawords= join(" ", ($$doc =~ m/<meta\s+(.*?)\s*>/gis));
	$extrawords=~s/\s+/ /gis;

	$$doc =~ s|<!--.*?-->||gs;
	$$doc =~ s!<head.*?>.*?</head.*?>!!gis;
	$$doc =~ s!<title.*?>.*?</title.*?>!!gis;
	$$doc =~ s!<script.*?>.*?</script.*?>!!gis;
	$$doc =~ s!<map.*?>.*?</map.*?>!!gis;
	$$doc =~ s!</?(html|body|meta|span|(no)?frame).*?>!!gis;
	$$doc =~ s!</?a(\s+.*?)?>!!gis;
	$$doc =~ s|</?!.*?>||gs;
	$$doc =~ s!<([^>]*)\sstyle=\'[^\']*\'!<$1!gs;
	$$doc =~ s!<([^>]*)\sclass=\w+!<$1!gs;
	$$doc =~ s!^\s+!!;
	$$doc =~ s!\n+!\n!g;
	$$doc =~ s![ \t]+! !gs;

	if ($summary) {
		$$summary =	 substr($$doc,0,$amount);
		$$summary =~ s/<.*?>//g;
		$amount  +=  ($amount - length($$summary));
		$$summary =	 substr($$doc,0,$amount);
#		$$summary =~ s/[^\n]+$//s;	# can cause problems with editors that make very long lines
		$$summary =~ s/<[^>]+$//;
		$$summary =~ s/\s*[^\s>]*$//;

		if ($frameflag) {
			$$summary = "[ This document uses frames -- the summary may be inaccurate ] " . $$summary;
		}
	}

	$$doc .= "\n\n";
	$$doc .= $$title if $title;
	$$doc .= "\n" . $extrawords . "\n";

	StripBadLines($doc);
	$$doc =~ s!<.*?>!!gs;
#	$$doc =~ s!\s+! !gs;
}

# end of Ferret::StripHTML
1;
