# NOTE: Derived from blib/lib/Ferret.pm.
# Changes made here will be lost when autosplit again.
# See AutoSplit.pm.
package Ferret;

#line 1301 "blib/lib/Ferret.pm (autosplit into blib/lib/auto/Ferret/StripMSWord.al)"
sub StripMSWord {
	my $usage = 'Usage: Ferret::StripMSWord(\$worddata [, \$title [, \$summary [, SUMMARYSIZE]]])';
	@_ >= 1 && @_ <= 4 or croak $usage;
	my($doc,$title,$summary,$amount) = @_;

	croak $usage if (ref $doc ne "SCALAR");
	croak $usage if ($title && ref $title ne "SCALAR");
	croak $usage if ($summary && ref $summary ne "SCALAR");
	$amount = 512 unless $amount;

	my $ctrls = chr(ord("S") - ord("@"));
	my $ctrlt = chr(ord("T") - ord("@"));
	my $ctrlu = chr(ord("U") - ord("@"));

	my $xlats = pack("H","91"."92"."93"."94");
	my $xlatd = q{''""};

#	my $sqopn = hex("91");
#	my $sqcls = hex("92");
#	my $dqopn = hex("93");
#	my $dqcls = hex("94");
#	my $bulet = hex("96");
#	$$doc =~ s/($sqopn|$sqcls)/'/g;	# '
#	$$doc =~ s/($dqopn|$dqcls)/"/g;	# "

	FixCRLF($doc);
	StripBadLines($doc);
	$$doc =~ y/$xlats/$xlatd/;

	if ($title) {
		if ($$doc=~m/$ctrls[^$ctrls$ctrlt$ctrlu]*TITLE[^$ctrls$ctrlt$ctrlu]*$ctrlt([^$ctrls$ctrlt$ctrlu]*)$ctrlu/so) {
			$$title = $1;
			$$title = "" unless (length($title) >= 5);
		} else {
			$$title = "";
		}
	}

	if ($summary) {
		if ($$doc=~m/$ctrls[^$ctrls$ctrlt$ctrlu]*COMMENTS[^$ctrls$ctrlt$ctrlu]*$ctrlt([^$ctrls$ctrlt$ctrlu]*)$ctrlu/so) {
			$$summary = $1;
		} else {
			$$summary = "";
		}
	}

	1 while ($$doc =~ s/$ctrls[^$ctrls$ctrlt$ctrlu]*$ctrlt([^$ctrls$ctrlt$ctrlu]*)$ctrlu/$1/gso);
	1 while ($$doc =~ s/$ctrls[^$ctrls$ctrlu]*$ctrlu//gso);

	$$doc =~ s/\x00[^\x00]{0,9}(?=\x00)//g;
	$$doc =~ s/\x07[^\x07]{0,9}(?=\x07)//g;
	$$doc =~ s/[\x00-\x09\x0B-\x0C\x0E-\x1F]/ /g;
	$$doc =~ s/^\s+|\s+$//g;

	if ($summary && !$$summary) {
		$$summary =	 substr($$doc,0,$amount);
		$$summary =~ s/\s*\n\s*\n/\n/g;
		$$summary =~ s/[^\n]*$//s;
#		$$summary =~ s/\s+\S*$//s;
	}

	$$doc .= "\n\n";
	$$doc .= $$title if $title;
#	$$doc =~ s!\s+! !gs;
}

# end of Ferret::StripMSWord
1;
