# NOTE: Derived from blib/lib/Ferret.pm.
# Changes made here will be lost when autosplit again.
# See AutoSplit.pm.
package Ferret;

#line 1515 "blib/lib/Ferret.pm (autosplit into blib/lib/auto/Ferret/StripMail.al)"
sub StripMail {
	my $usage = 'Usage: Ferret::StripMail(\$maildata [, \$title [, \$summary [, SUMMARYSIZE]]])';
	@_ >= 1 && @_ <= 4 or croak $usage;
	my($doc,$title,$summary,$amount) = @_;
	my($head);

	croak $usage if (ref $doc ne "SCALAR");
	croak $usage if ($title && ref $title ne "SCALAR");
	croak $usage if ($summary && ref $summary ne "SCALAR");
	$amount = 512 unless $amount;

	FixCRLF($doc);

	# Remove MIME encoding information
	if ($$doc =~ m/^content-type:.*boundary="(.*?)"/mi) {
		my $mb = $1;
		$$doc =~ s/\n\s*-*$mb\s+.*?\n\s*\n/\n\n/gs;
	}
#	_Time("Remove MIME");

	$head = substr($$doc,0,$amount+1000);
	if ($title) {
		$$title = "";
		($$title) = ($head =~ m/^subject:\s*(.*?)$/mi);
	}
#	_Time("Extract Title");

	if ($summary) {
		$$summary =  $head;
		$$summary =~ s/(^|\n)(From|Received:) .*?\n\s*\n/$1\n/sg;
		$$summary =~ s!^[\W\d\n]*\n!!;
		$$summary =  substr($$summary,0,$amount);
		$$summary =~ s/[^\n]*$//s;
	}
#	_Time("Extract Summary");

#	$$doc =~ s/^[\W\d\n]*\n//;
#	$$doc =~ s/\n+/\n/g;

	StripBadLines($doc);
#	_Time("Remove Bad-Lines");
}

# end of Ferret::StripMail
1;
