# NOTE: Derived from blib/lib/Ferret.pm.
# Changes made here will be lost when autosplit again.
# See AutoSplit.pm.
package Ferret;

#line 1388 "blib/lib/Ferret.pm (autosplit into blib/lib/auto/Ferret/StripPostscript.al)"
sub StripPostscript {
	my $usage = 'Usage: Ferret::StripPostscript(\$textdata [, \$title [, \$summary [, SUMMARYSIZE]]])';
	@_ >= 1 && @_ <= 4 or croak $usage;
	my($doc,$title,$summary,$amount) = @_;

	croak $usage if (ref $doc ne "SCALAR");
	croak $usage if ($title && ref $title ne "SCALAR");
	croak $usage if ($summary && ref $summary ne "SCALAR");
	$amount = 512 unless $amount;

	FixCRLF($doc);

	if ($title) {
		$$title = "";
		if ($$doc =~ m/^%%Title:\s*\((.*)\)/m) {
			if ($1 !~ m/untitled/i) {
				$$title = $1;
				$$title =~ s!\\\(!\(!g;
				$$title =~ s!\\\)!\)!g;
				$$title =~ s!\\(\d{3})!chr(oct($1))!ge;
				$$title =~ y!\x92\x93\x94!\'\"\"!;
				$$title =~ s![\x80-\xFF]!!g;

				$$title =  "" unless (length($title) >= 5);
			}
		}
	}

	$$doc =~ s!\\\(!\\050!g;
	$$doc =~ s!\\\)!\\051!g;

	$$doc =~ s!\\\n!!g;							# join broken lines
	$$doc =~ s!\s*\n+!\n!g;						# remove trailing whitespace
	$$doc =~ s!\G.*?\n%%BeginPageSetup\n(.*?)\n%%EndPage\n!$_=$1;s/^.*%%EndPageSetup\n//s;$_!gse;
	$$doc =~ s!^\S+$!!mg;						# remove encoded binary data
	$$doc =~ s!^[^()]*$!\n!mg;					# strip non-text lines
	$$doc =~ s!^%%.*$!!mg;						# strip comments/info
	$$doc =~ s!^/.*$!!mg;						# strip control directives
	$$doc =~ s!.*?\((.*?)\)[^()\n]*!$1!g;		# extract text
	$$doc =~ s!^\S+$!!mg;						# strip text that has no spacing <sigh>
	$$doc =~ s!\s*\n\s*\n!\n!g;

	$$doc =~ s!\\251!(c)!g;
	$$doc =~ s!\\(\d{3})!chr(oct($1))!ge;
	$$doc =~ y!\x92\x93\x94!\'\"\"!;
	$$doc =~ s![\x80-\xFF]!!g;

	if ($summary) {
		$$summary =	 substr($$doc,0,$amount);
		$$summary =~ s/[^\n]*$//s;
	}

	StripBadLines($doc);
#	$$doc =~ s/\s+/ /g;
}

# end of Ferret::StripPostscript
1;
